void ByteToBinaryStr(unsigned short input, char *output);
void WordToBinaryStr(unsigned input, char *output);
void LongWordToBinaryStr(unsigned long input, char *output);
unsigned short BinaryToGray(unsigned short num);
unsigned short GrayToBinary(unsigned short num);

void ByteToBinaryStr(unsigned short input, char *output)
{
  char i;

  output[8] = 0;
  for(i = 8;i>0;)
  {
    output[--i] = input % 2 + 48;
    input = input / 2;
  }
}

void WordToBinaryStr(unsigned input, char *output)
{
  unsigned int i;

  output[16] = 0;
  for(i = 16;i>0;)
  {
    output[--i] = input % 2 + 48;
    input = input / 2;
  }
}

void LongWordToBinaryStr(unsigned long input, char *output)
{
  unsigned int i;

  output[32] = 0;
  for(i = 32;i>0;)
  {
    output[--i] = input % 2 + 48;
    input = input / 2;
  }
}

// The reflected binary code, also known as Gray code, is a binary numeral system
// where two successive values differ in only one bit
//  Dec  Gray   Binary
//   0   000    000
//   1   001    001
//   2   011    010
//   3   010    011
//   4   110    100
//   5   111    101
//   6   101    110
//   7   100    111
unsigned short BinaryToGray(unsigned short num)
{
  return (num>>1) ^ num;
}

unsigned short GrayToBinary(unsigned short num)
{
  unsigned short temp;
  temp = num ^ (num>>8);
  temp ^= (temp>>4);
  temp ^= (temp>>2);
  temp ^= (temp>>1);
  return temp;
}