/*
 * Project name:       
     Conversions (Demonstration of using additional Conversions Library)
 * Copyright:
     (c) Mikroelektronika, 2010.
 * Revision History:
     20100702:
       - initial release;
 * Description:
     This program demonstrates usage of additional Conversions Library routines. 
     Compile and run the code through software simulator.          
 * Test configuration:
     MCU:             PIC16F887
                      http://ww1.microchip.com/downloads/en/DeviceDoc/41291F.pdf
     Dev.Board:       EasyPIC6
                      http://www.mikroe.com/en/tools/easypic6/
     Oscillator:      HS, 08.0000 MHz
     Ext. Modules:    -
     SW:              mikroC PRO for PIC
                      http://www.mikroe.com/en/compilers/mikroc/pro/pic/
 * NOTES:
     - None.
*/

char byte[9];
char word[17];
char longg[33];
char tmp;

void main() {
ByteToBinaryStr(0xAA,byte);     // Convert byte to binary string '10101010'
ByteToBinaryStr(0x55,byte);     // Convert byte to binary string '01010101'

WordToBinaryStr(0xF0F0,word);   // Convert word to binary string '1111000011110000'
WordToBinaryStr(0xAA55,word);

ByteToBinaryStr(0xFC,byte);
ByteToBinaryStr(0xCF,byte);

WordToBinaryStr(0xF0F0,word);
WordToBinaryStr(0xAA55,word);

LongWordToBinaryStr(0xF0F0F0F0, longg);

tmp = BinaryToGray(5);// 7      // Convert 8-bit binary to Gray code
tmp = GrayToBinary(7);// 5      // Convert Gray code to binary 

tmp = BinaryToGray(59);// 38
tmp = GrayToBinary(38);// 59

tmp = BinaryToGray(255);// 128
tmp = GrayToBinary(128);// 255

}